// AboutDlg.cpp : implementation file
//

#include "stdafx.h"
#include "liteedit.h"
#include "AboutDlg.h"
#include "ConfigData.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AboutDlg dialog


AboutDlg::AboutDlg(CWnd* pParent /*=NULL*/)
	: CDialog(AboutDlg::IDD, pParent), mModuleLoader(TEXT("RICHED32.DLL"))
{
	//{{AFX_DATA_INIT(AboutDlg)
	//}}AFX_DATA_INIT
}


void AboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(AboutDlg)
	DDX_Control(pDX, IDC_RICHEDIT, mEdit);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(AboutDlg, CDialog)
	//{{AFX_MSG_MAP(AboutDlg)
	ON_WM_HELPINFO()
	ON_NOTIFY(EN_LINK, IDC_RICHEDIT, OnLinkRichedit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// AboutDlg message handlers

LPCTSTR E_MAIL = TEXT("reumuth@rocketmail.com");
LPCTSTR URL = TEXT("http://www.reumuth.com/programming");

BOOL AboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CString text = PROGRAM_NAME_AND_VER;
	text += TEXT("\r\nOctober 2004\r\n\r\nJimmy Reumuth\r\n");
	text += E_MAIL;
	text += TEXT("\r\n");
	text += URL;
	text += TEXT("\r\n\r\n\r\nPrevious Versions:\r\n");
	text += TEXT("-----------------------------\r\n");
	text += TEXT("1.0 - March 2004");
	
	mEdit.SetWindowText(text);

	LinkifyText(mEdit, E_MAIL);
	LinkifyText(mEdit, URL);

	DWORD mask = mEdit.GetEventMask();
	mask |= ENM_LINK;
	mEdit.SetEventMask(mask);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL AboutDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	return TRUE;
}

void AboutDlg::OnLinkRichedit(NMHDR* pNMHDR, LRESULT* pResult) 
{
	ENLINK* link = (ENLINK*)pNMHDR;

	if (link->msg == WM_LBUTTONDOWN && link->wParam == MK_LBUTTON) {
		CString text;
		TEXTRANGE tr;
		MemClear(tr);
		tr.chrg = link->chrg;
		tr.lpstrText = text.GetBuffer(100);
		mEdit.SendMessage(EM_GETTEXTRANGE, 0, (WPARAM)&tr);
		text.ReleaseBuffer();

		//prefix the link with mailto: so ShellExecute() will be able to execute it
		if (text == E_MAIL) {
			CString temp = TEXT("mailto:") + text;
			text = temp;
		}
			
		DWORD err = (DWORD)ShellExecute(m_hWnd, TEXT("open"), text, NULL, NULL, SW_SHOWDEFAULT);
		ATLASSERT(err > 32);
	}

	*pResult = 0;
}
