// PromptDlg.cpp : implementation file
//

#include "stdafx.h"
#include "liteedit.h"
#include "PromptDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// PromptDlg dialog


PromptDlg::PromptDlg(const CString& promptStr, CWnd* pParent /*=NULL*/)
	: CDialog(PromptDlg::IDD, pParent), mPromptStr(promptStr)
{
	//{{AFX_DATA_INIT(PromptDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void PromptDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(PromptDlg)
	DDX_Control(pDX, IDC_STATIC_PROMPT, mStaticPrompt);
	DDX_Control(pDX, IDC_EDIT, mEdit);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(PromptDlg, CDialog)
	//{{AFX_MSG_MAP(PromptDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// PromptDlg message handlers

BOOL PromptDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	//add trailing colin if there isn't one already
	if (!mPromptStr.IsEmpty() && mPromptStr.GetAt(mPromptStr.GetLength() - 1) != ':')
		mPromptStr += ':';

	mStaticPrompt.SetWindowText(mPromptStr);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void PromptDlg::OnOK() 
{
	mEdit.GetWindowText(mText);
		
	CDialog::OnOK();
}
