// UninstallerCaller.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include <stdlib.h>
#include <assert.h>

#ifdef _DEBUG
	#define verify(x) assert(x)
#else
	#define verify(x) (x)
#endif

const char* LogFileName = "Uninstall.log";
const char* ExeFileName = "RealUninstall.exe";

template<class T>
void MemSet(T& data, BYTE value) {
	memset(&data, value, sizeof(data));
}

template<class T>
void MemClear(T& data) {
	MemSet(data, 0x00);
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	char tempDir[MAX_PATH];
	strcpy(tempDir, getenv("temp"));
	strcat(tempDir, "\\");

	char path[MAX_PATH];
	strcpy(path, tempDir);
	strcat(path, LogFileName);
	verify(CopyFile(LogFileName, path, FALSE));

	strcpy(path, tempDir);
	strcat(path, ExeFileName);
	verify(CopyFile(ExeFileName, path, FALSE));

	DWORD flags = 0;
	STARTUPINFO startUpInfo;
	PROCESS_INFORMATION procInfo;
	MemClear(startUpInfo);
	startUpInfo.cb = sizeof(startUpInfo);

	char exe[MAX_PATH];
	strcpy(exe, "\"");
	strcat(exe, path);
	strcat(exe, "\"");

	BOOL succ = CreateProcess(NULL, exe, NULL, NULL, FALSE, flags, NULL, tempDir, &startUpInfo, &procInfo);
	assert(succ);

	return 0;
}