// SetupDlg.h : header file
//

#if !defined(AFX_SETUPDLG_H__F31D4C3B_9A4D_4536_9814_6C3F23CC852D__INCLUDED_)
#define AFX_SETUPDLG_H__F31D4C3B_9A4D_4536_9814_6C3F23CC852D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Utility.h"

/////////////////////////////////////////////////////////////////////////////
// CSetupDlg dialog

#define DECL_BOOL_PROP(id, name) \
	bool Get##name() { \
		return GetCheck(::GetDlgItem(m_hWnd, id)); \
	} \
	void Set##name(bool val) { \
		SetCheck(::GetDlgItem(m_hWnd, id), val); \
	}

class CSetupDlg : public CDialog
{
// Construction
public:
	CSetupDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CSetupDlg)
	enum { IDD = IDD_SETUP_DIALOG };
	CButton	mCheckSendTo;
	CButton	mBtnInstall;
	CEdit	mEditDir;
	CButton	mCheckDesktop;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSetupDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
private:
	void UpdateEnable();

protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CSetupDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonExit();
	afx_msg void OnButtonBrowse();
	afx_msg void OnButtonInstall();
	afx_msg void OnChangeEditDir();
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SETUPDLG_H__F31D4C3B_9A4D_4536_9814_6C3F23CC852D__INCLUDED_)
